<%
	const repositoryClass = pascalCase(params.name) + "Repository";
	const repositoryVar = camelCase(params.name) + "Repository";

	const nestjsImports = new Set(["Controller"]);

	if (params.controllerEndpoints.includes("getMany")) {
		nestjsImports.add("Get")
		nestjsImports.add("Query")
		nestjsImports.add("ParseIntPipe");
	}

	if (params.controllerEndpoints.includes("getOne")) {
		nestjsImports.add("Get")
		nestjsImports.add("Param");
	}
%>

import { <%- Array.from(nestjsImports).join(", ") %> } from "@nestjs/common";

import { <%= repositoryClass %> } from "./<%= kebabCase(params.name) %>.repository.js";

@Controller("<%= kebabCase(params.name) %>")
export class <%= pascalCase(params.name) %>Controller {
	constructor(protected <%= repositoryVar %>: <%= repositoryClass %>) {}
<% if (params.controllerEndpoints.includes("getMany")) { %>

	@Get()
	getMany(
		@Query("page", ParseIntPipe) page: number,
		@Query("pageSize", ParseIntPipe) pageSize: number,
	) {
		return this.<%= repositoryVar %>.getMany(
			{},
			{
				pagination: { page, pageSize },
			},
		);
	}
<% } %>
<% if (params.controllerEndpoints.includes("getOne")) { %>

	@Get(":id")
	getOne(@Param("id") id: string) {
		return this.<%= repositoryVar %>.getOneById(id);
	}
<% } %>
}
